//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "buildStatus.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TbuildStatus_Form *buildStatus_Form;
//---------------------------------------------------------------------------


#include "main.h"
#include "ide_main.h"
#include "ide_library.h"
#include "ide_msgbox.h"
#include "gui.h"
//[2009.04.20.월][추가!!!]
#include "editor_edit.h"
#include "ide_editor.h"
#include "tree_tree.h"
#include "msg_msg.h"
#include "ide_BalloonBox.h"

//[2009.05.27.수][추가!!!]
#include  "file.h"


//[2011.04.27.수][생성!!!!]{------------------------------------------------------------
//<projectWizard_Form> 을 가지고 생성한 것으로 [가상기계 제작] 시 여러 상태를 표시한다.
//더불어, BCB 와 같이 [중지] 기능을 제공하는데 이는 이 창이 [보이지 않게] 되면
//[중지] 시키는 의미로 처리한다.
//}-------------------------------------------------------------------------------------


//[서브클래싱]------------------------------------------------------------------

void __fastcall TbuildStatus_Form::WndProc(Messages::TMessage  &Message)
{
  //[설명!!!]{--------------------------------------------------------------------
  //TForm 의 경우는 바탕을 칠하고 OnPaint() 를 발생하게 되므로 실제 _Draw() 를
  //OnPaint() 에서 사용하는 경우는 크기가 변경되는 경우 바로 칠해지지 않아서
  //하얀색 바탕이 그대로 나오게 되어 보기 좋지 않게 된다.
  //따라서 TForm 자체의 바탕을 그리는 WM_ERASEBKGND 에서 바로 _Draw() 를 사용하여
  //그리고 OnPaint() 는 처리하지 않는다.
  //C++Builder 와 같이 완벽하게 처리되는 깜박임이 전혀 없는 화면을 만들수 있다.
  //}-----------------------------------------------------------------------------

  if(Message.Msg == WM_ERASEBKGND)
  {
    _Draw();

    //바로 죵료하지 않으면 WM_ERASEBKGND 메세지가 다음 TForm::WndProc(Message); 에서
    //다시 처리 되어 TForm->Color 로 칠해지게 되어 _Draw() 로 그린 것이 다 지워지므로
    //바로 종료한다.
    return;

  }

  //[기본처리]
  //{
      //기본 메세지는 반드시 처리 되어야 한다.
      TForm::WndProc(Message);
  //}

  return;

}

//------------------------------------------------------------------------------

__fastcall TbuildStatus_Form::TbuildStatus_Form(TComponent* Owner)
        : TForm(Owner)
{
  //[VAR]
  //{
      AnsiString     bmp_path;
      int            width, height;

      TRect          colorBoxTRect;
      int            w, h;

      int            i;

      //[2009.10.03.토][추가!!!]
      int            color;

  //}

  //[환경변수]
  //{
      //[2007.10.02.화][추가!!!]
      IDE_Get_Option(&_ide_option);

  //}

  //[초기화]
  //{
      //--------------------------------------------------------------------------
      //크기는 표시되는 내용에 따라 자동으로 처리 되지만 일단 임의 값을 기록한다.
      this->Left     = 0;
      this->Top      = 0;
      this->Width    = 400;
      this->Height   = 135;
      this->Color    = clWhite;

      //실제 그림 영역을 생성한다.
      _bmp_ = new Graphics::TBitmap;

      //그림 영역 크기 설정.
      _bmp_->Width       = this->Width;
      _bmp_->Height      = this->Height;

      //24bit bitmap 으로 지정한다.
      _bmp_->PixelFormat = pf24bit;
      //--------------------------------------------------------------------------
  //}

  //[글꼴 설정]
  //{
      //[기본 끌꼴 등록]{------------------------------------------------
      //모든 프로그램에서 기본적으로 사용하는 [system 글꼴] 을 등록한다.
      FONTPACK_SetDefault(&_font);
      //}----------------------------------------------------------------

      //[editor debug margin]
      //{
          _font.margin_size = 0;

      //}

      //문자 margin 을 설정한다.
      _font.offset_left   = 0;
      _font.offset_right  = 0;
      _font.offset_top    = 0;
      _font.offset_bottom = 0;

      //[2010.01.26.화][추가!!!]{---
      _font.en_offset_left  = 0;
      _font.en_offset_right = 0;
      //}---------------------------

  //}

  //[속성초기화]
  //{
      //기본적으로 선택되지 않은 상태.
      _caption_selected = false;

  //}

  //[caption 설정]
  //{
      //caption 문자열.(크게 바뀔일이 없다.)
      STR_Assign(_caption, " 가상기계 제작 진행 상황 ");

      //높이 지정.
      _caption_height = 22;

      //caption 문자열의 width 를 구한다.
      FONT_Get_StringOutAreaInfo(&_font, d_FONTSTYLE_default, _caption, &width, &height);

      //실제 사용할 caption 폭을 설정한다.
      //_font.margin_size 는 처음 기본값인 0 을 사용한다.(한번만 그려주면 된다.)
      _caption_width = width + (_font.margin_size * 2) + 2;

  //}

  //[컨트롤 생성]
  //{
      //[닫기 버튼]
      //{
          _close_bmpbtns          = new Tgui_bmpbutton_Form(this);
          _close_bmpbtns->Parent  = this;
          _close_bmpbtns->Visible = true;

          //[초기화]
          //{
              //그림 할당하기.
              bmp_path = ExtractFilePath(Application->ExeName) + "sysbmp\\control\\close.bmp";

              _close_bmpbtns->_Top(0);
              _close_bmpbtns->_Width(12);
              _close_bmpbtns->_Left(0);
              _close_bmpbtns->_Height(12);
              _close_bmpbtns->_Border(true);
              _close_bmpbtns->_Bitmap(bmp_path);
              _close_bmpbtns->_Image_Width(12);
              _close_bmpbtns->_Image_Height(12);

              //동작함수 등록.
              _close_bmpbtns->_EVENT_Click = _EVENT_CloseButton_Click;

          //}

      //}

  //}

  //[설정 컨트롤 생성]
  //{
      //[200904.19.일][추가!!!]{---------------------
      //설정용 대화상자의 각각의 설정 내용을 만든다.
      //}--------------------------------------------

      //[배경색 설정]{--------------------------------------------------------------------------
      //바탕색을 설정한다.
      BMP_Get_Bright_Color(_ide_option->color_0, Ide_Bright_BuildStatusLabelBack, &_colorBack);
      //}---------------------------------------------------------------------------------------

      //[문서 전체 이름]
      //{
          //[제목]
          //{
              _fileNameTitle_Label          = new Tgui_Label_Form(this);
              _fileNameTitle_Label->Parent  = this;
              _fileNameTitle_Label->Visible = true;

              _fileNameTitle_Label->_Width(80);
              _fileNameTitle_Label->_Height(20);
              _fileNameTitle_Label->_Top(24);
              _fileNameTitle_Label->_Left(4 - 1 + 3);
              _fileNameTitle_Label->_FontColor(clWhite);
              _fileNameTitle_Label->_BackColor(_colorBack);
              _fileNameTitle_Label->_Border(true);

              _fileNameTitle_Label->_FontXY(2, 4);
              _fileNameTitle_Label->_Caption("문서전체이름");

          //}

          //[내용]
          //{
              _fileName_Label          = new Tgui_Label_Form(this);
              _fileName_Label->Parent  = this;
              _fileName_Label->Visible = true;

              _fileName_Label->_Width(this->Width - (_fileNameTitle_Label->Width + 11));
              _fileName_Label->_Height(20);
              _fileName_Label->_Top(24);
              _fileName_Label->_Left(_fileNameTitle_Label->Left + _fileNameTitle_Label->Width - 1);
              _fileName_Label->_Border(true);

              _fileName_Label->_FontXY(4, 4);
              _fileName_Label->_Caption("");

          //}

      //}

      //[문서 이름]
      //{
          //[제목]
          //{
              _fileNameOnlyTitle_Label          = new Tgui_Label_Form(this);
              _fileNameOnlyTitle_Label->Parent  = this;
              _fileNameOnlyTitle_Label->Visible = true;

              _fileNameOnlyTitle_Label->_Width(80);
              _fileNameOnlyTitle_Label->_Height(20);
              _fileNameOnlyTitle_Label->_Top(_fileName_Label->Top + _fileName_Label->Height + 2);
              _fileNameOnlyTitle_Label->_Left(4 - 1 + 3);
              _fileNameOnlyTitle_Label->_FontColor(clWhite);
              _fileNameOnlyTitle_Label->_BackColor(_colorBack);
              _fileNameOnlyTitle_Label->_Border(true);

              _fileNameOnlyTitle_Label->_FontXY(2, 4);
              _fileNameOnlyTitle_Label->_Caption("문서이름");

          //}

          //[내용]
          //{
              _fileNameOnly_Label          = new Tgui_Label_Form(this);
              _fileNameOnly_Label->Parent  = this;
              _fileNameOnly_Label->Visible = true;

              _fileNameOnly_Label->_Width(this->Width - (_fileNameOnlyTitle_Label->Width + 11));
              _fileNameOnly_Label->_Height(20);
              _fileNameOnly_Label->_Top(_fileName_Label->Top + _fileName_Label->Height + 2);
              _fileNameOnly_Label->_Left(_fileNameOnlyTitle_Label->Left + _fileNameOnlyTitle_Label->Width - 1);
              _fileNameOnly_Label->_Border(true);

              _fileNameOnly_Label->_FontXY(4, 4);
              _fileNameOnly_Label->_Caption("");

          //}

      //}

      //[현재 처리 행]
      //{
          //[제목]
          //{
              _lineNumTitle_Label          = new Tgui_Label_Form(this);
              _lineNumTitle_Label->Parent  = this;
              _lineNumTitle_Label->Visible = true;

              _lineNumTitle_Label->_Width(80);
              _lineNumTitle_Label->_Height(20);
              _lineNumTitle_Label->_Top(_fileNameOnly_Label->Top + _fileNameOnly_Label->Height + 2);
              _lineNumTitle_Label->_Left(4 - 1 + 3);
              _lineNumTitle_Label->_FontColor(clWhite);
              _lineNumTitle_Label->_BackColor(_colorBack);
              _lineNumTitle_Label->_Border(true);

              _lineNumTitle_Label->_FontXY(2, 4);
              _lineNumTitle_Label->_Caption("현재처리행");

          //}

          //[내용]
          //{
              _lineNum_Label          = new Tgui_Label_Form(this);
              _lineNum_Label->Parent  = this;
              _lineNum_Label->Visible = true;

              _lineNum_Label->_Width(this->Width/2 - (_fileNameOnlyTitle_Label->Width + 11));
              _lineNum_Label->_Height(20);
              _lineNum_Label->_Top(_fileNameOnly_Label->Top + _fileNameOnly_Label->Height + 2);
              _lineNum_Label->_Left(_fileNameOnlyTitle_Label->Left + _fileNameOnlyTitle_Label->Width - 1);
              _lineNum_Label->_Border(true);

              _lineNum_Label->_FontXY(4, 4);
              _lineNum_Label->_Caption("00000000");

          //}

      //}

      //[총 처리 행]
      //{
          //[제목]
          //{
              _totalLineNumTitle_Label          = new Tgui_Label_Form(this);
              _totalLineNumTitle_Label->Parent  = this;
              _totalLineNumTitle_Label->Visible = true;

              _totalLineNumTitle_Label->_Width(80);
              _totalLineNumTitle_Label->_Height(20);
              _totalLineNumTitle_Label->_Top(_lineNum_Label->Top);
              _totalLineNumTitle_Label->_Left(_lineNum_Label->Left + _lineNum_Label->Width + 2);
              _totalLineNumTitle_Label->_FontColor(clWhite);
              _totalLineNumTitle_Label->_BackColor(_colorBack);
              _totalLineNumTitle_Label->_Border(true);

              _totalLineNumTitle_Label->_FontXY(2, 4);
              _totalLineNumTitle_Label->_Caption("전체처리행수");

          //}

          //[내용]
          //{
              _totalLineNum_Label          = new Tgui_Label_Form(this);
              _totalLineNum_Label->Parent  = this;
              _totalLineNum_Label->Visible = true;

              _totalLineNum_Label->_Width(this->Width/2 - (_totalLineNumTitle_Label->Width + 1));
              _totalLineNum_Label->_Height(20);
              _totalLineNum_Label->_Top(_lineNum_Label->Top);
              _totalLineNum_Label->_Left(_totalLineNumTitle_Label->Left + _totalLineNumTitle_Label->Width - 1);
              _totalLineNum_Label->_Border(true);

              _totalLineNum_Label->_FontXY(4, 4);
              _totalLineNum_Label->_Caption("00000000");

          //}

      //}

      //[진행막대]
      //{
          //[2011.04.28.목][추가!!!]
          _build_Progress          = new Tgui_Progress_Form(this);
          _build_Progress->Parent  = this;
          _build_Progress->Visible = true;

          _build_Progress->_Height(10);
          _build_Progress->_Left(4 - 1 + 3);
          _build_Progress->_Width(this->Width - 12);
          _build_Progress->_Top(_totalLineNum_Label->Top + _totalLineNum_Label->Height + 2);

          //진행막대색을 설정한다.
          BMP_Get_Bright_Color(_ide_option->color_0, Ide_Bright_Progress, &(_build_Progress->_progressColor));

          _build_Progress->_Min(0);
          _build_Progress->_Max(100);
          _build_Progress->_Progress(50);

      //}

      //[중지]
      //{
          _stop_Btn          = new Tgui_button_Form(this);
          _stop_Btn->Parent  = this;
          _stop_Btn->Visible = true;

          _stop_Btn->_Width(80);
          _stop_Btn->_Height(20);
          _stop_Btn->_Top(_build_Progress->Top + _build_Progress->Height + 6);
          _stop_Btn->_Left(this->Width/2 - _stop_Btn->Width/2 - 6);
          _stop_Btn->_Caption_AutoPos(true);
          _stop_Btn->_Caption("취소");

          _stop_Btn->_EVENT_Click = _EVENT_Click_stop_Btn;

      //}
      
  //}

  //[그리기]
  //{
      _Shape();

  //}

  //[폼 위치 조정]
  //{
      //폼이 항상 화면의 중앙에 나오도록 위치를 조정한다.
      this->Left = Screen->Width/2  - this->Width/2;
      this->Top  = Screen->Height/2 - this->Height/2;

  //}

  //[초기화]
  //{
      //2011.04.28.목][추가!!!]
      _Init();

  //}

  return;

}

__fastcall TbuildStatus_Form::~TbuildStatus_Form(void)
{
  //[2012.04.30.월][수정!!!]{---------------
  //안전을 위하여 선언한 역순으로 삭제한다.
  //}---------------------------------------

  if(_stop_Btn != NULL) { delete _stop_Btn; _stop_Btn = NULL; }

  if(_build_Progress != NULL) { delete _build_Progress; _build_Progress = NULL; }

  if(_totalLineNum_Label != NULL) { delete _totalLineNum_Label; _totalLineNum_Label = NULL; }

  if(_totalLineNumTitle_Label != NULL) { delete _totalLineNumTitle_Label; _totalLineNumTitle_Label = NULL; }

  if(_lineNum_Label != NULL) { delete _lineNum_Label; _lineNum_Label = NULL; }

  if(_lineNumTitle_Label != NULL) { delete _lineNumTitle_Label; _lineNumTitle_Label = NULL; }

  if(_fileNameOnly_Label != NULL) { delete _fileNameOnly_Label; _fileNameOnly_Label = NULL; }

  if(_fileNameOnlyTitle_Label != NULL) { delete _fileNameOnlyTitle_Label; _fileNameOnlyTitle_Label = NULL; }

  if(_fileName_Label != NULL) { delete _fileName_Label; _fileName_Label = NULL; }

  if(_fileNameTitle_Label != NULL) { delete _fileNameTitle_Label; _fileNameTitle_Label = NULL; }

  if(_close_bmpbtns != NULL) { delete _close_bmpbtns; _close_bmpbtns = NULL; }

  if(_bmp_ != NULL) { delete _bmp_; _bmp_ = NULL; }

}

//------------------------------------------------------------------------------

void __fastcall TbuildStatus_Form::_FormCut(void)
{
  //[2006.11.07.화][생성!!!]{----------------------------------------------------
  //폼의 caption 의 모양을 보기 좋게 하기 위하여 caption 의 영역을 제외한 나머지
  //영역의 폼을 제거해 준다.(구멍을 뚫어준다.)
  //여러개의 [사각형] 모양으로 구멍을 뚫어준다.
  //}----------------------------------------------------------------------------

  //[VAR]
  //{
      HRGN    rgn_main,                              //대상 폼.
              rgn_cut_rect,                          //caption 오른쪽 영역 전부.
              rgn_cut_left_line, rgn_cut_left_dot,   //수평line, dot.
              rgn_cut_right_line, rgn_cut_right_dot; //수평line, dot.
  //}


  //[Form 초기화]
  //{
      //포인터 초기화.
      rgn_main = 0;

      //Form 의 영역 정보를 얻는다.
      GetWindowRgn(this->Handle, rgn_main);

      //일단 현재 Form 영역을 지운다.
      DeleteObject(rgn_main);
  //}

  //[영역 생성]
  //{
      //새로운 영역을 생성한다.
      rgn_main = CreateRectRgn(0, 0, this->Width, this->Height);

      //[구멍 뚫을 영역 지정]
      //{
          //caption 오른쪽 영역.
          rgn_cut_rect       = CreateRectRgn(_caption_width, 0, this->Width, 18);

          //좌측 라인.
          rgn_cut_left_line  = CreateRectRgn(0, 0, 2, 1);

          //좌측 점.
          rgn_cut_left_dot   = CreateRectRgn(0, 1, 1, 2);

          //우측 라인.
          rgn_cut_right_line = CreateRectRgn(_caption_width - 2, 0, _caption_width, 1);

          //우측 점.
          rgn_cut_right_dot  = CreateRectRgn(_caption_width - 1, 1, _caption_width, 2);

      //}

      CombineRgn(rgn_main, rgn_main, rgn_cut_rect, RGN_DIFF);
      CombineRgn(rgn_main, rgn_main, rgn_cut_left_line, RGN_DIFF);
      CombineRgn(rgn_main, rgn_main, rgn_cut_left_dot, RGN_DIFF);
      CombineRgn(rgn_main, rgn_main, rgn_cut_right_line, RGN_DIFF);
      CombineRgn(rgn_main, rgn_main, rgn_cut_right_dot, RGN_DIFF);

      SetWindowRgn(this->Handle, rgn_main, TRUE);
  //}

  //[구멍 뚫기]
  //{
      //--------------------------------
      //지정 영역에 구멍을 뚫는다.
      DeleteObject(rgn_cut_rect);
      DeleteObject(rgn_cut_left_line);
      DeleteObject(rgn_cut_left_dot);
      DeleteObject(rgn_cut_right_line);
      DeleteObject(rgn_cut_right_dot);
      //--------------------------------
  //}

  return;

}

void __fastcall TbuildStatus_Form::_Border(void)
{
  //[설명!!!]{----------------------------------------------------------------
  //Form 전체의 테두리를 만든다.
  //두께는 4pixel, 동서남 3 면만 그리면 된다.
  //테두리는 직접 보이는 것이고 내용에 영향을 주지 않아야 하므로 직접 그린다.

  //[2007.03.18.일][수정!!!]
  //1 pixel 의 [통합개발환경] 전체 테두리를 마지막에 그려준다.
  //이는 윤곽을 더 뚜렷하게 하기 위한 것이다.
  //}-------------------------------------------------------------------------

  //[VAR]
  //{
      TRect            trect;
  //}

  //[테두리 만들기]
  //{
      //[좌측 테두리]{-------------------------------
      trect.Left   = 0;
      trect.Top    = 0;
      trect.Right  = d_border_width;
      trect.Bottom = _bmp_->Height;

      _bmp_->Canvas->Brush->Color = _ide_option->color_0;
      _bmp_->Canvas->FillRect(trect);
      //[우측 테두리]{-------------------------------
      trect.Left   = _bmp_->Width - d_border_width;
      trect.Top    = 0;
      trect.Right  = _bmp_->Width;
      trect.Bottom = _bmp_->Height;

      _bmp_->Canvas->Brush->Color = _ide_option->color_0;
      _bmp_->Canvas->FillRect(trect);
      //[아래 테두리]{-------------------------------
      trect.Left   = 0;
      trect.Top    = _bmp_->Height - d_border_width;
      trect.Right  = _bmp_->Width;
      trect.Bottom = _bmp_->Height;

      _bmp_->Canvas->Brush->Color = _ide_option->color_0;
      _bmp_->Canvas->FillRect(trect);
      //---------------------------------------------
  //}

  //[윤곽선 만들기]
  //{
      //[2007.03.18.일][추가!!!]
      if(d_OPTION_msgbox_outline)
      {
        //[왼쪽]
        _bmp_->Canvas->Pen->Color = IDE_COLOR_outline;
        _bmp_->Canvas->MoveTo(0, 2);
        _bmp_->Canvas->LineTo(0, this->Height);

        //[오른쪽]
        _bmp_->Canvas->Pen->Color = IDE_COLOR_outline;
        _bmp_->Canvas->MoveTo(this->Width - 1, 0);
        _bmp_->Canvas->LineTo(this->Width - 1, this->Height);

        //[아래쪽]
        _bmp_->Canvas->Pen->Color = IDE_COLOR_outline;
        _bmp_->Canvas->MoveTo(0, this->Height - 1);
        _bmp_->Canvas->LineTo(this->Width - 1, this->Height - 1);

        //[제목줄 위쪽]
        _bmp_->Canvas->Pen->Color = IDE_COLOR_outline;
        _bmp_->Canvas->MoveTo(2, 0);
        _bmp_->Canvas->LineTo(_caption_width-3, 0);

        //[오늘쪽 위쪽]
        _bmp_->Canvas->Pen->Color = IDE_COLOR_outline;
        _bmp_->Canvas->MoveTo(_caption_width -1 , _caption_height - d_border_width);
        _bmp_->Canvas->LineTo(this->Width - 1, _caption_height - d_border_width);

        //[제목줄 오른쪽]
        _bmp_->Canvas->Pen->Color = IDE_COLOR_outline;
        _bmp_->Canvas->MoveTo(_caption_width -1 , 2);
        _bmp_->Canvas->LineTo(_caption_width -1, _caption_height - d_border_width);

        //[제목줄 왼쪽위 모서리]
        _bmp_->Canvas->Pen->Color = IDE_COLOR_outline;
        _bmp_->Canvas->MoveTo(2 , 0);
        _bmp_->Canvas->LineTo(0, 2);

        //[제목줄 오른쪽위 모서리]
        _bmp_->Canvas->Pen->Color = IDE_COLOR_outline;
        _bmp_->Canvas->MoveTo(_caption_width-3 , 0);
        _bmp_->Canvas->LineTo(_caption_width -1, 2);

      }
      
  //}

  return;

  /*

  //[내부 테두리 만들기]
  //{
      //[2010.12.15.수][추가!!!]{-----------
      //보기 좋게 내부에도 테두리를 만든다.
      //}-----------------------------------

      trect.Left   = d_border_width - 1;
      trect.Top    = _caption_height + d_border_width - 1;
      trect.Right  = this->Width - d_border_width + 1;
      trect.Bottom = this->Height - d_border_width + 1;

      _bmp_->Canvas->Pen->Color   = IDE_COLOR_outline;
      _bmp_->Canvas->Pen->Width   = 1;
      _bmp_->Canvas->Brush->Style = bsClear;

      _bmp_->Canvas->Rectangle(trect);

  //}

  return;

  */

}

void __fastcall TbuildStatus_Form::_Shape(void)
{
  //[2007.09.26.수][생성!!!]{---
  //컨트롤의 모양을 만든다.
  //}---------------------------

  //[VAR]
  //{
      TRect  rect;
      TRect  rect_caption;

      int    w, h;

      int    width, height;

  //}

  //[제목줄 폭 구하기]
  //{
      //caption 문자열의 width 를 구한다.
      FONT_Get_StringOutAreaInfo(&_font, d_FONTSTYLE_default, _caption, &width, &height);

      //실제 사용할 caption 폭을 설정한다.
      //_font.margin_size 는 처음 기본값인 0 을 사용한다.(한번만 그려주면 된다.)
      _caption_width = width + (_font.margin_size * 2) + 2;

  //}

  //[수정]
  //{
      //[닫기] 버튼의 폭과 배치를 반영하여 폭을 늘려준다.
      _caption_width += (_close_bmpbtns->Width + 4);

  //}

  //[폼 오려내기]
  //{
      _FormCut();

  //}

  //[모양 그리기]
  //{
      //[전체 배경 처리]
      //{
          //[영역정보]{-------------------
          rect = _bmp_->Canvas->ClipRect;
          //}-----------------------------

          //[바탕 지우기]{---------------------------
          _bmp_->Canvas->Brush->Color = IDE_COLOR_2;
          _bmp_->Canvas->FillRect(rect);
          //}----------------------------------------

      //}

      //[caption 처리]
      //{
          //[caption 영역]{----------------------
          rect_caption = rect;
          rect_caption.Bottom = _caption_height;
          //}------------------------------------

          //[caption 바탕 지우기]{-------------------
          _bmp_->Canvas->Brush->Color = _ide_option->color_0;
          _bmp_->Canvas->FillRect(rect_caption);
          //}----------------------------------------

          //[caption 문자열]
          //{
              //----------------------------------------------------------------------------------
              _font.margin_size = 0;

              //FONT_Out_String2(_bmp_, &_font, 0, 5, IDE_COLOR_3, _ide_option->color_0, true,
              //                 _caption,
              //                 d_FONT_underline_no, true, 0, IDE_COLOR_1,
              //                 &w, &h);

              //[2007.12.15.토][수정!!!]
              //위의 함수를 [형식] 을 적용할수 있는 이 함수로 바꾼다.
              FONT_Out_StyleString2(_bmp_, &_font, 0, 5, IDE_COLOR_3, _ide_option->color_0, true,
                                    d_FONTSTYLE_default,
                                    _caption,
                                    d_FONT_underline_no, true, 0, IDE_COLOR_1,
                                    &w, &h);
              //----------------------------------------------------------------------------------
          //}

      //}

      //[닫기 단추 배치]
      //{
          _close_bmpbtns->_Top(5);
          _close_bmpbtns->_Left(_caption_width - _close_bmpbtns->Width - 5);

          //[단추 배경 지우기]
          //{
              rect.Left   = _close_bmpbtns->Left - 1;
              rect.Top    = _close_bmpbtns->Top  - 1;
              rect.Right  = _close_bmpbtns->Left + _close_bmpbtns->Width  + 1;
              rect.Bottom = _close_bmpbtns->Top  + _close_bmpbtns->Height + 1;

              _bmp_->Canvas->Brush->Color = IDE_COLOR_2;
              _bmp_->Canvas->FillRect(rect);

          //}

      //}

  //}

  //[테두리]
  //{
      _Border();

  //}

  //[view]{-------------
  //그린 것을 보여준다.
  _Draw();
  //}-------------------

  return;

}

void __fastcall TbuildStatus_Form::_Draw(void)
{
  BitBlt(this->Canvas->Handle, 0, 0,
         this->Width, this->Height,
         _bmp_->Canvas->Handle, 0, 0, SRCCOPY);

  return;

}

void __fastcall TbuildStatus_Form::_Caption(char  *pCaption)
{
  //[2007.12.14.금][생성!!!]{-------------------------------------------------------
  //[제목줄] 문자열을 지정된 문자열로 바꾸어 주고 전체를 다시 그려준다.
  //[제목줄] 이 달라지면 폼을 다시 오려 주어야 하므로 다시 전체를 그려 주어야 한다.
  //}-------------------------------------------------------------------------------

  //[VAR]
  //{
      int            width, height;

  //}

  //[caption 설정]
  //{
      //caption 문자열.(크게 바뀔일이 없다.)
      STR_Assign(_caption, pCaption);

      //높이 지정.
      _caption_height = 22;

      //caption 문자열의 width 를 구한다.
      FONT_Get_StringOutAreaInfo(&_font, d_FONTSTYLE_default, _caption, &width, &height);

      //실제 사용할 caption 폭을 설정한다.
      //_font.margin_size 는 처음 기본값인 0 을 사용한다.(한번만 그려주면 된다.)
      _caption_width = width + (_font.margin_size * 2) + 2;

  //}

  //[그리기]
  //{
      _Shape();

  //}

  return;

}

void __fastcall TbuildStatus_Form::_Width(int  pWidth)
{
  //[2007.12.14.금][생성!!!]{-----------------------------------------------------------
  //폭을 바꾸어 주고 _bmp_ 등 관련 부분도 다 수정하고 폼도 다시 오려주고 다시 그려준다.
  //}-----------------------------------------------------------------------------------

  //[크기 조정]
  //{
      //지정 폭으로 폭을 조정한다.
      _bmp_->Width = pWidth;

      this->Width  = pWidth;

  //}

  //[그리기]
  //{
      _Shape();

  //}

  return;

}

void __fastcall TbuildStatus_Form::_Height(int  pHeight)
{
  //[2007.12.14.금][생성!!!]{-------------------------------------------------------------
  //높이를 바꾸어 주고 _bmp_ 등 관련 부분도 다 수정하고 폼도 다시 오려주고 다시 그려준다.
  //}-------------------------------------------------------------------------------------

  //[크기 조정]
  //{
      //지정 폭으로 폭을 조정한다.
      _bmp_->Height = pHeight;

      this->Height  = pHeight;

  //}

  //[그리기]
  //{
      _Shape();

  //}

  return;

}

//------------------------------------------------------------------------------
//[동작홤수들]------------------------------------------------------------------
//------------------------------------------------------------------------------

void __fastcall TbuildStatus_Form::_EVENT_CloseButton_Click(void)
{
  //[2007.09.26.수][생성!!!]{---
  //이 폼을 닫는다.
  //}---------------------------

  this->Close();

  return;

}

void __fastcall TbuildStatus_Form::_EVENT_Click_stop_Btn(void)
{
  //[2011.04.28.목][생성!!!]{-----------------------------------------------
  //이 창을 닫는 것은 [가상기계 제작을 즁지] 한다는 의미가 된다.
  //다른 곳에서 이 창의 <Visible> 속성으로 [중지  여부를 판별하기 때문이다.
  //}-----------------------------------------------------------------------

  //닫아준다.
  this->Close();

  return;

}

//------------------------------------------------------------------------------

void __fastcall TbuildStatus_Form::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  //[2007.09.26.수][생성!!!]{-------
  //현재 [폼 이동] 처리에 사용한다.
  //}-------------------------------

  //[VAR]
  //{
      //[2018.03.17.토][추가!!!]
      TPoint  mousePos;

  //}

  //[전광판]
  //{
      //[2010.04.03.토][추가!!!]{-----------------------------
      //[전광판] 을 일시 정지 시킨다.
      //이는 이동, 크기조정시 끊어짐 현상을 막기 위한 것이다.
      //}-----------------------------------------------------

      ide_editor_Form->_GDotMatrix_RotateTemp(false);

  //}

  //[캡션바] 영역에서만 처리되어야 한다.
  if(((0 <= X) && (X < _caption_width)) &&
     ((0 <= Y) && (Y < _caption_height)))
  {
    if(Button == mbLeft)
    {
      //[위치 기록]
      //{
          //[2018.03.17.토][수정!!!]{-----------------------------------------------------
          //[전체화면] 을 대상으로한 위치 사용.
          //이는 <GVmos> 등 다른 Form 안에 생성되는 경우에도 동일하게 동작 시키기 위한것.
          //}-----------------------------------------------------------------------------

          //[전체화면] 을 대상으로 마우스 위치 얻기.
          GetCursorPos(&mousePos);

          //현재 <this> 위치와 [마우스] 위치 간의 거리 얻기.
          //항상 같은 거리를 유지하는 방법으로 [제목줄 이동] 을 구현하기 위한것.
          deltaLeft = mousePos.x - this->Left;
          deltaTop  = mousePos.y - this->Top;

      //}
      
      //caption 이 선택된 것을 알린다.
      _caption_selected = true;

      //[wine 지원]
      //{
          //[2018.03.03.토][추가!!!]{---------
          //[제목줄] 이동을 위한 타이머 켜기.
          //}---------------------------------

          if(_ide_option->wine == true)
          {
            captionMoveTimer->Enabled = true;

          }

      //}

    }

  }   

  return;

}

void __fastcall TbuildStatus_Form::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  //[2007.09.26.수][생성!!!]{----------------------
  //마우스로 caption 을 집어 끄는 경우를 처리한다.
  //}----------------------------------------------

  //[VAR]
  //{
      //[2018.03.17.토][추가!!!]
      TPoint  mousePos;

  //}

  //[캡션바 이동]
  //{
      //[캡션바] 영역에서만 처리되어야 한다.
      if(((0 <= X) && (X < _caption_width)) &&
         ((0 <= Y) && (Y < _caption_height)) ||
         //마우스로 집어  끄는 경우 영역을 벗어난 경우도 처리 되어야 한다.
         //이는 집어 끌다가 놓치는 경우를 막기 위한 것이다.
         (Shift.Contains(ssLeft)))
      {
        if((Shift.Contains(ssLeft)) && (_caption_selected == true))
        {
          //caption 을 마우스로 집어끄는 경우 Form 을 이동 시켜야 한다.

          //[wine 지원]
          //{
              //[2018.03.03.토][추가!!!]{-------------------------------
              //<Linux:wine> 에서 구동 중이라면 여기서 처리하지 않는다.
              //<captionMoveTimerTimer()> 안에서 처리된다.
              //}-------------------------------------------------------

              if(_ide_option->wine == true)
              {
                //[Linux:wine]
                //이 경우 아래에서 사용하는 <Left>, <Top> 값은 <captionMoveTimer> 안에서
                //수정되고 있는 정확한 값으로 처리.

              }
              else
              {
                //[윈도우]

                //[위치 이동]
                //{
                    //[2018.03.17.토][수정!!!]{-----------------------------------------------------
                    //[전체화면] 을 대상으로한 위치 사용.
                    //이는 <GVmos> 등 다른 Form 안에 생성되는 경우에도 동일하게 동작 시키기 위한것.
                    //}-----------------------------------------------------------------------------

                    //[전체화면] 을 대상으로 마우스 위치 얻기.
                    GetCursorPos(&mousePos);

                    //현재 <this> 위치와 [마우스] 위치 간의 거리를
                    //항상 같은 거리로 유지하는 방법으로 [제목줄 이동] 을 구현.
                    this->Left = mousePos.x - deltaLeft;
                    this->Top  = mousePos.y - deltaTop;

                //}

              }

          //}

        }

      }

  //}

  return;

}

void __fastcall TbuildStatus_Form::FormMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  //[2007.09.26.수][생성!!!]

  //[wine 지원]
  //{
      //[2018.03.03.토][추가!!!]{---------
      //[제목줄] 이동을 위한 타이머 끄기.
      //}---------------------------------

      if(_ide_option->wine == true)
      {
        //<FormMouseUp> 에서는 무조건 타이머 정지.
        captionMoveTimer->Enabled = false;

      }

  //}

  //[전광판]
  //{
      //[2010.02.23.화][추가!!!]{--------------
      //[전광판] 을 다시 정지에서 해제시킨다.
      //}--------------------------------------

      ide_editor_Form->_GDotMatrix_RotateTemp(true);

  //}

  if(((0 <= X) && (X < _caption_width)) &&
     ((0 <= Y) && (Y < _caption_height)))
  {
    if(Button == mbRight)
    {

    }

  }

  //[해제]
  //{
      //caption 선택을 해제한다.
      _caption_selected = false;

  //}

  return;

}

//------------------------------------------------------------------------------------------
//[제어 함수들]-----------------------------------------------------------------------------
//------------------------------------------------------------------------------------------

void __fastcall TbuildStatus_Form::_Init(void)
{
  //[2011.04.28.목][생성!!!]{---
  //모든 항목을 초기화 한다.
  //}---------------------------

  //[환경변수]
  //{
      //2011.04.28.목][추가!!!]
      _totalLineNum = 0;

  //}

  //[그림부품]
  //{
      _fileName_Label->_Caption("http://www.gigyenics.co.kr");

      _fileNameOnly_Label->_Caption("기계닉스 첨단 대장간");

      _lineNum_Label->_Caption("0");

      _totalLineNum_Label->_Caption("0");

  //}

}

void __fastcall TbuildStatus_Form::_FileInfo(char *pFileName,
                                             //문서 총 행수(진행막대 설정에 필요).
                                             int   pFileLineCount)
{
  //[2011.04.28.목][생성!!!]{-------------------------------------
  //[문서전체이름] 을 설정한다.
  //단, [문서이름] 만 별도 추출하여 이것도 같이 처리해 준다.
  //
  //더불어, 반드시 [진행막대] 도 초기화 해준다.
  //이는 모든 처리의 시작이 [새로운 문서] 가 열릴때이기 때문이다.
  //
  //[2011.04.30.토][수정!!!]
  //}-------------------------------------------------------------

  //[VAR]
  //{
      //[2011.04.30.토][추가!!!]
      //{DATABASE} 의 본체 주소값을 가지는 pointer.
      class DATABASE  *database;

      char  fileNameOnly[OPT_lineStrSize];

      //[2011.04.30.토][추가!!!]
      //[설계묶음] 안의 경로만 저장한다.
      char  filePathInGprj[OPT_lineStrSize];

      char  tempStr[OPT_lineStrSize];

  //}

  //[Database 의 주소를 얻기]
  //{
      DATABASE_GetPtr(&database);

  //}

  //[전체 이름 출력]
  //{
      //[2011.04.30.토][수정!!!]{-------------------------------------------------
      //전체 경로는 너무 길어 정작 중요한 정보가 표시되지 않으므로
      //[설계묶음] 안의 경로만 표시하는 것으로 수정한다.
      //
      //"[설계묶음]\경로...."
      //
      //형태가 된다.
      //[설계묶음] 이 있는 [폴더이름] 으로 하는 경우는 너무 긴 경우가 있어 결과가
      //마찬가지다. 따라서, "[설계묶음]" 문자열로 대체한다.
      //}-------------------------------------------------------------------------

      STR_GetFileName_Except_BaseDirectory(database->projectpath, pFileName, filePathInGprj);

      STR_Assign(tempStr, "[설계묶음]\\"); STR_Add(tempStr, filePathInGprj);

      _fileName_Label->_Caption(tempStr);

  //}

  //[문서 이름만 출력]
  //{
      //먼저 <*.*> 로 경로를 제외한 [이름] 만 얻는다.
      STR_GetFileNameOnly(pFileName, fileNameOnly);

      //문서 이름만 춝력.
      _fileNameOnly_Label->_Caption(fileNameOnly);

  //}

  //[초기화]
  //{
      //[현재행]
      //{
          _lineNum_Label->_Caption("0");

      //}

      //진행막대]
      //{
          _build_Progress->_Progress(0);
          //_Min() 은 항상 0 이므로 굳이 초기화 할 필요가 없다.
          //_build_Progress->_Min(0);
          //이 문서의 총 행수가 [최대값] 이 된다.
          _build_Progress->_Max(pFileLineCount);

      //}

  //}

}

void __fastcall TbuildStatus_Form::_LineNum(int  pLineNum)
{
  //[2011.04.28.목][생성!!!]{----------------------------------------------------
  //현재 처리행을 표시한다.
  //[값] 으로 전달 되므로 내부적으로 10진수로 바꾸어 표시한다.
  //더불어, [진행막대] 도 수정한다.
  //
  //이 함수는 너무 자주 호추로디지 않도록, 사용하는 쪽에서 [행이 변경된 경우] 나
  //일정한 양만큼 증가한 경우만 호출되도록 할 필요가 있다.
  //그렇지 않은 경우는 전체적인 처리 시간이 증가되는 역효과가 발생한다.
  //
  //[총 처리 행수] 는 별도의 전용 함수로 처리되므로 여기서는 처리하지 않는다.
  //}----------------------------------------------------------------------------

  //[VAR]
  //{
      char  tempStr[OPT_lineStrSize];

  //}

  //[현재행 표시]
  //{
      //[값=> 문자열] 변환.
      CONV_LongVal_To_Str(pLineNum,
                          //[자리수:0] 인 경우는 공백을 <0> 으로 매꾸지 않는다.
                          0,
                          false,
                          tempStr);

      //[현재행] 출력.
      _lineNum_Label->_Caption(tempStr);

  //}

  //[진행막대]
  //{
      _build_Progress->_Progress(pLineNum);

  //}

}

void __fastcall TbuildStatus_Form::_TotalLineNum(void)
{
  //[2011.04.29.금][생성!!!]{-------------------------------------------------------
  //[전체 처리 행수] 를 표시한다.
  //[값] 으로 전달 되므로 내부적으로 10진수로 바꾸어 표시한다.
  //
  //다른 부가 처리 없이 단순하게 정해진 위치에 문자열로 출력만 해 주면 된다.
  //
  //이 함수는 너무 자주 호추로디지 않도록 <_LineNum()> 함수가 호출되는 시점에
  //이 함수도 같이 호출하여 처리하는 방법을 사용한다.
  //
  //[주의!!!]-----------------------------------------------------------------------
  //[총 처리행 수] 는 어떤 경우라도 [포함될수 있는 처리대상의 전부] 를 의미하며
  //[가상기계 제작] 중 만들어 지는 모든 문서를 대상을 하므로 이곳에서 [환경변수] 로
  //관리된다.
  //따라서, 별도의 인수로 값을 전달 받을 필요가 없이 내부 [환경변수] 값을 사용한다.
  //}-------------------------------------------------------------------------------

  //[VAR]
  //{
      char  tempStr[OPT_lineStrSize];

  //}

  //[총행수 표시]
  //{
      //[값=> 문자열] 변환.
      CONV_LongVal_To_Str(_totalLineNum,
                          //[자리수:0] 인 경우는 공백을 <0> 으로 매꾸지 않는다.
                          0,
                          false,
                          tempStr);

      //[현재행] 출력.
      _totalLineNum_Label->_Caption(tempStr);

  //}

}

void __fastcall TbuildStatus_Form::_On(void)
{
  //[2011.04.29.금][생성!!!]{---------------------------------
  //[진행 상태 창] 을 보여주고 완전히 초기화 한다.
  //
  //이 함수는 <IDE_Build()> 함수에서 시작시 한번만 사용된다.
  //
  //[2012.05.05.토][수정!!!]----------------------------------
  //[맷돌C:GUI] 동작후 [가장 앞으로 보이기] 안되는 문제 수정.
  //}---------------------------------------------------------

  _Init();

  //[주의!!!][2012.05.05.토]{-----------
  //반드시 아래 순서대로 처리해야 한다.
  //
  //1) this->FormStyle = fsNormal;
  //2) this->FormStyle = fsStayOnTop;
  //3) this->BringToFront();
  //4) this->Show();
  //}-----------------------------------

  //[2012.05.05.토][추가!!!]{------------------------------------------
  //아래 <this->BringToFront()> 추가와 같은 이유인데
  //원래 지정한 것이나 재지정한다.
  //단, 어떤 이유인지는 알수 없으나 [맷돌C:GUI] 를 돌린후 우선순위
  //문제로 [가장 앞으로 보이기] 가 제대로 복구되지 않는 경우가 있다.
  //이를 완전히 초기화 하기 위하여 [기본폼] 으로 다시 지정후
  //[가장위] 로 다시 지정하면 다시 완벽하게 복구된다.
  //실험결과 여러 상황에서도 문제 없이 잘 [가장 위로 보이기] 동작된다.
  this->FormStyle = fsNormal;
  this->FormStyle = fsStayOnTop;
  //}------------------------------------------------------------------

  //[2012.05.03.목][추가!!!]{-----------------------------------------------
  //[맷돌C] 로 GUI 환경을 개발하는 경우 [그림부품] 에서 <BringToFront()> 를
  //사용하는 경우 다음부터 [맷돌-통합개발환경] 뒤로 가버리는 문제가 있다.
  //따라서, 반드시 보일때는 [가장위] 에 위치하도록 한다.
  this->BringToFront();
  //}-----------------------------------------------------------------------

  //[주의!!!]{-----------------------------
  //절대 <ShowModal()> 로 보여주지 않는다.
  //이 경우 [빌드] 진행이 되지 않는다.
  this->Show();
  //}--------------------------------------

}

void __fastcall TbuildStatus_Form::_Off(void)
{
  //[2011.04.29.금][생성!!!]{--------------------------------
  //[진행 상태 창] 을 감춘다.
  //
  //이 함수는 <IDE_Build()> 함수에서 시작시 한번만 사용된다.
  //}--------------------------------------------------------

  this->Close();

}

void __fastcall TbuildStatus_Form::captionMoveTimerTimer(TObject *Sender)
{
  //[2018.03.03.토][생성!!!]{---------------------------
  //[Linux:wine] 에서 [제목줄:이동] 을 지원하기 위한것.
  //}---------------------------------------------------

  //[VAR]
  //{
      TPoint  mousePos;

  //}

  //[위치 수정]
  //{
      //[!]{-----------------------------------------------------------------------------
      //이전 방식은 <Linux:wine> 에서는 빠르게 이동하는 경우 [떨림] 현상이 생기고
      //이동이 끊어지는 문제가 발생.
      //이는 <Linux:wine> 에서 [제목줄] 밖으로 [화면지정자] 가 나가는 경우를 제대로
      //처리하지 못하는 문제인듯.
      //따라서, 기존처럼 [상대좌표] 를 사용하지 않고 [절대좌표] 를 사용하는 것으로 수정.
      //}--------------------------------------------------------------------------------

      //[마우스 절대 위치 얻기]
      //{
          //화면상의 [마우스] 절대 위치를 얻는다.
          GetCursorPos(&mousePos);

      //}

      //[이동]
      //{
          //[2018.03.17.토][수정!!!]{---------------------------------
          //현재 <this> 위치와 [마우스] 위치 간의 거리를
          //항상 같은 거리로 유지하는 방법으로 [제목줄 이동] 을 구현.
          //자세한 내용은 [제목줄 이동] 관련 부분 설명 연관 참고.
          //}---------------------------------------------------------
          
          this->Left = mousePos.x - deltaLeft;
          this->Top  = mousePos.y - deltaTop;

      //}

  //}

}






